﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SpreadComboTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        DataTable dt;
        private void Form1_Load(object sender, EventArgs e)
        {
            FarPoint.Win.Spread.SolidFocusIndicatorRenderer Focus = new FarPoint.Win.Spread.SolidFocusIndicatorRenderer(Color.Transparent, 2);
            FarPoint.Win.Spread.InputMap im;

            spgrdActivityDetails.FocusRenderer = Focus;
            spgrdActivityDetails.SetCursor(FarPoint.Win.Spread.CursorType.Normal, System.Windows.Forms.Cursors.Default);
            spgrdActivityDetails.EditModePermanent = true;

            dt = new DataTable();
            dt.Columns.Add("Screen_Name");
            dt.Columns.Add("Code_Name");
            dt.Rows.Add("John", "JOHN");
            dt.Rows.Add("Adams", "ADAMS");
            dt.Rows.Add("Smith", "SMITH");
            dt.Rows.Add("Steve", "STEVE");
            dt.Rows.Add("Tara", "TARA");
            dt.Rows.Add("Jack", "JACK");
            dt.Rows.Add("Roodey", "ROODEY");

            int iARow;
            FarPoint.Win.Spread.CellType.DateTimeCellType dtCellType = new FarPoint.Win.Spread.CellType.DateTimeCellType();
            spgrdActivityDetails.Sheets[0].RowCount = spgrdActivityDetails.Sheets[0].RowCount + 1;
            iARow = spgrdActivityDetails.Sheets[0].RowCount - 1;
            spgrdActivityDetails.Sheets[0].Cells[iARow, 0].CellType = dtCellType;
            spgrdActivityDetails.Sheets[0].Cells[iARow, 0].Value = DateTime.Today;
            spgrdActivityDetails.ActiveSheet.Cells[iARow, 0].CellType = dtCellType;
            spgrdActivityDetails.Sheets[0].Cells[iARow, 2].Value = "John";
            spgrdActivityDetails.Sheets[0].Cells[iARow, 7].Value = "Y";
            spgrdActivityDetails.Sheets[0].Cells[iARow, 8].Value = "NEW";

            FarPoint.Win.Spread.FpSpread mySpread = new FarPoint.Win.Spread.FpSpread();
            FarPoint.Win.Spread.SheetView sv = new FarPoint.Win.Spread.SheetView();
            mySpread.Sheets.Add(sv);
            this.panel1.Controls.Add(mySpread);
            mySpread.Location = new Point(20, 0);
            mySpread.Size = new Size(350, 200);
            FarPoint.Win.Spread.CellType.ComboBoxCellType cmbocell = new FarPoint.Win.Spread.CellType.ComboBoxCellType();
            cmbocell.Items = (new String[] { "January", "February", "March", "April", "May", "June" });
            cmbocell.AutoSearch = FarPoint.Win.AutoSearch.SingleCharacter;
            cmbocell.Editable = true;
            cmbocell.MaxDrop = 3;
            mySpread.ActiveSheet.Cells[0, 0].CellType = cmbocell;
        }

        private void spgrdActivityDetails_CellClick(object sender, FarPoint.Win.Spread.CellClickEventArgs e)
        {
            if(e.ColumnHeader)
            {
                return;
            }
            if (e.Column == 1)
            {
                spgrdActivityDetails.Sheets[0].OperationMode = FarPoint.Win.Spread.OperationMode.RowMode;
                spgrdActivityDetails.Sheets[0].SetActiveCell(e.Row, 1, false);
                string strLogPolicy = spgrdActivityDetails.Sheets[0].Cells[e.Row, e.Column].Text;
                FarPoint.Win.Spread.CellType.ComboBoxCellType cellType = new FarPoint.Win.Spread.CellType.ComboBoxCellType();
                spgrdActivityDetails.Sheets[0].Cells[e.Row, e.Column].CellType = cellType;
                cellType.Items = dt.AsEnumerable().Select(c => c.Field<string>("Screen_Name")).ToArray();
                cellType.ItemData = dt.AsEnumerable().Select(c => c.Field<string>("Code_Name")).ToArray();
                cellType.EditorValue = FarPoint.Win.Spread.CellType.EditorValue.ItemData;
                cellType.AcceptsArrowKeys = FarPoint.Win.SuperEdit.AcceptsArrowKeys.AllArrowsIgnoringMultiline;
                cellType.AutoSearch = FarPoint.Win.AutoSearch.SingleCharacter;
                cellType.MaxDrop = 3;
                cellType.AllowArrowKeysMoveActiveCell = FarPoint.Win.Spread.FlagArrowKeys.All;
                cellType.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.SuggestAppend;
                cellType.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.ListItems;
                spgrdActivityDetails.Sheets[0].Cells[e.Row, e.Column].Text = strLogPolicy;
            }

            if (e.Column == 2)
            {
                spgrdActivityDetails.EditMode = false;
            }

            if (e.Column == 3)
            {
                spgrdActivityDetails.ActiveSheet.Cells[e.Row, e.Column].CellType = new FarPoint.Win.Spread.CellType.TextCellType();
            }
        }

        private void spgrdActivityDetails_ComboSelChange(object sender, FarPoint.Win.Spread.EditorNotifyEventArgs e)
        {
            if (e.Column == 1)
            {
                string strCode;
                strCode = spgrdActivityDetails.Sheets[0].Cells[e.Row, 1].Text;
                spgrdActivityDetails.Sheets[0].Cells[e.Row, 4].Value = spgrdActivityDetails.Sheets[0].Cells[e.Row, 1].Value.ToString();
                spgrdActivityDetails.ActiveSheet.Cells[e.Row, e.Column].CellType = new FarPoint.Win.Spread.CellType.TextCellType();
                spgrdActivityDetails.Sheets[0].Cells[e.Row, 1].Value = strCode;
            }
        }
    }
}
